/*----- PROTECTED REGION ID(DaresburyClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        DaresburyClass.h
//
// description : Include for the Daresbury root class.
//               This class is the singleton class for
//                the Daresbury device class.
//               It contains all properties and methods which the 
//               Daresbury requires only once e.g. the commands.
//
// project :     Daresbury
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef DaresburyClass_H
#define DaresburyClass_H

#include <tango.h>
#include <Daresbury.h>


/*----- PROTECTED REGION END -----*/	//	DaresburyClass.h


namespace Daresbury_ns
{
/*----- PROTECTED REGION ID(DaresburyClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	DaresburyClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Interlocks class definition
class InterlocksAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for Interlocks attribute
	constexpr static long X_DATA_SIZE = 1024;
	InterlocksAttrib():SpectrumAttr("Interlocks",
			Tango::DEV_SHORT, Tango::READ, InterlocksAttrib::X_DATA_SIZE) {}
	~InterlocksAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Daresbury *>(dev))->read_Interlocks(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Daresbury *>(dev))->is_Interlocks_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command DevRead class definition
class DevReadClass : public Tango::Command
{
public:
	DevReadClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	DevReadClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~DevReadClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_DevRead_allowed(any);}
};

//	Command GetAllDescription class definition
class GetAllDescriptionClass : public Tango::Command
{
public:
	GetAllDescriptionClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetAllDescriptionClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetAllDescriptionClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_GetAllDescription_allowed(any);}
};

//	Command GetHistoryInfo class definition
class GetHistoryInfoClass : public Tango::Command
{
public:
	GetHistoryInfoClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetHistoryInfoClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetHistoryInfoClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_GetHistoryInfo_allowed(any);}
};

//	Command GetInterlockDescription class definition
class GetInterlockDescriptionClass : public Tango::Command
{
public:
	GetInterlockDescriptionClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetInterlockDescriptionClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetInterlockDescriptionClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_GetInterlockDescription_allowed(any);}
};

//	Command GetInterlockState class definition
class GetInterlockStateClass : public Tango::Command
{
public:
	GetInterlockStateClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetInterlockStateClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetInterlockStateClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_GetInterlockState_allowed(any);}
};

//	Command ReadInterlockHistory class definition
class ReadInterlockHistoryClass : public Tango::Command
{
public:
	ReadInterlockHistoryClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ReadInterlockHistoryClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ReadInterlockHistoryClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_ReadInterlockHistory_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_Reset_allowed(any);}
};

//	Command SetInterlockDescription class definition
class SetInterlockDescriptionClass : public Tango::Command
{
public:
	SetInterlockDescriptionClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	SetInterlockDescriptionClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~SetInterlockDescriptionClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_SetInterlockDescription_allowed(any);}
};

//	Command EnableSMS class definition
class EnableSMSClass : public Tango::Command
{
public:
	EnableSMSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	EnableSMSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~EnableSMSClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_EnableSMS_allowed(any);}
};

//	Command DisableSMS class definition
class DisableSMSClass : public Tango::Command
{
public:
	DisableSMSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	DisableSMSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~DisableSMSClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_DisableSMS_allowed(any);}
};

//	Command GetSMS class definition
class GetSMSClass : public Tango::Command
{
public:
	GetSMSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetSMSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetSMSClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Daresbury *>(dev))->is_GetSMS_allowed(any);}
};


/**
 *	The DaresburyClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  DaresburyClass : public Tango::DeviceClass
#else
class DaresburyClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(DaresburyClass::Additional DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::Additional DServer data members

	public:
		//	Class properties data members
		//	SMSDevice:	Name of the SMS device
		std::string	sMSDevice;
		//	SMSPhoneNumber:	
		std::string	sMSPhoneNumber;
		//	MailDest:	List of mail adress
		std::vector<std::string>	mailDest;
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static DaresburyClass *init(const char *);
		static DaresburyClass *instance();
		~DaresburyClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		DaresburyClass(std::string &);
		static DaresburyClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	Daresbury_H
